package com.qmth.eds.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qmth.eds.bean.dto.CloudMarkingScoreDto;
import com.qmth.eds.bean.dto.ExamSyncStudentDto;
import com.qmth.eds.bean.result.StudentMarkResult;
import com.qmth.eds.common.entity.CloudMarkingScore;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Set;

/**
 * 云阅卷成绩表 Mapper 接口
 */
public interface CloudMarkingScoreMapper extends BaseMapper<CloudMarkingScore> {

    IPage<CloudMarkingScoreDto> pageData(@Param("page") Page<CloudMarkingScoreDto> page, @Param("collegeId") Long collegeId, @Param("semesterId") Long semesterId, @Param("examTypeId") Long examTypeId, @Param("examId") String examId);

    /**
     * 根据科目代码查询
     *
     * @param schoolId
     * @param semesterId
     * @param orgId
     * @param courseCode
     * @return
     */
    List<CloudMarkingScore> queryBySyncCourseCode(@Param("schoolId") Long schoolId, @Param("semesterId") Long semesterId, @Param("orgId") Long orgId, @Param("courseCode") String courseCode);

    List<ExamSyncStudentDto> listExamSyncStudentDtos(@Param("schoolId") Long schoolId, @Param("semesterId") Long semesterId, @Param("examTypeId") Long examTypeId, @Param("courseCode") String courseCode, @Param("openCollege") String openCollege);

    List<StudentMarkResult> queryStudentMark(@Param("schoolId") Long schoolId,
                                             @Param("orgId") Long orgId,
                                             @Param("semesterId") Long semesterId,
                                             @Param("examId") Long examId,
                                             @Param("subjectCode") String subjectCode,
                                             @Param("collegeName") String collegeName,
                                             @Param("subjectCodeSet") Set<String> subjectCodeSet);
}
